<ng-container *transloco="let t; prefix: 'userInformationPage'">
  <eui-page>
    <eui-page-header [label]="t('title')">
      <eui-page-header-action-items>
        <button euiButton euiPrimary class="eui-u-mt-s" type="button" (click)="navigateToUserCreation()">
          <eui-icon-svg icon="eui-ecl-plus"></eui-icon-svg>
          {{ t('newUser') }}
        </button>
    </eui-page-header-action-items>
    </eui-page-header>
    <eui-page-content>
      <eui-page-columns>
        <eui-page-column euiResizable [isCollapsed]="true" [isCollapsible]="true" euiSizeVariant="xl" label="Filters">
          <eui-page-column-body>
            <form [formGroup]="filtersForm" class="d-flex flex-column gap-2" id="filtersForm" (ngSubmit)="search()">
              <div euiInputGroup>
                <label euiLabel for="email">{{ t('filters.email') }}</label>
                <input euiInputText id="email" formControlName="email"
                  placeholder="{{t('filters.placeholder.email')}}" />
              </div>
              <div euiInputGroup>
                <label euiLabel for="firstName">{{ t('filters.firstName') }}</label>
                <input euiInputText id="firstName" formControlName="firstName"
                  placeholder="{{t('filters.placeholder.firstName')}}" />
              </div>
              <div euiInputGroup>
                <label euiLabel for="lastName">{{ t('filters.lastName') }}</label>
                <input euiInputText id="lastName" formControlName="lastName"
                  placeholder="{{t('filters.placeholder.lastName')}}" />
              </div>
              <div euiInputGroup>
                <label euiLabel for="username">{{ t('filters.username') }}</label>
                <input euiInputText id="username" formControlName="username"
                  placeholder="{{t('filters.placeholder.username')}}" />
              </div>
              <eui-button-group class="eui-u-display-flex eui-u-inline-flex">
                <button euiButton id="resetButton" [disabled]="loading()" type="button" class="eui-u-width-50"
                  euiSecondary (click)="resetFilters()">
                  {{ t('filters.reset') }}
                </button>
                <button euiButton id="submitButton" [disabled]="loading()" type="submit" class="eui-u-width-50"
                  euiPrimary>
                  {{ t('filters.search') }}
                </button>
              </eui-button-group>
            </form>
          </eui-page-column-body>
        </eui-page-column>

        <eui-page-column>
          <eui-page-column-body>
            <div class="eui-u-display-flex eui-u-mb-m eui-u-flex-align-items-center">
              @if(chips.length){
                <div class="eui-u-mr-xs eui-u-p-2xs eui-u-flex-column eui-u-flex-gap-none">
                  <span>
                    Selected criteria
                  </span>
                  <span class="eui-u-text-link" (click)="resetFilters()" onKeyPress>
                    Clear All
                  </span>
                </div>
                <eui-chip-list (chipRemove)="removeChip($event)">
                  @for (chip of chips; track $index) {
                    <eui-chip [id]="chip.field" [data]="{id: chip.field}" isFilled isChipRemovable class="eui-u-mr-2xs eui-u-mb-2xs">
                      <span euiLabel>{{ t('filters.' + chip.field) }}: {{ chip.value }}</span>
                    </eui-chip>
                  }
                </eui-chip-list>
              }
            </div>
            <div class="eui-table-v2__scrollable-wrapper">
              <table euiTableV2 isTableResponsive [data]="paginatedItems" [isLoading]="loading()">
                <ng-template euiTemplate="header">
                  <tr>
                    <th isSortable sortOn="email">{{ t('email') }}</th>
                    <th>{{ t('firstName') }}</th>
                    <th>{{ t('lastName') }}</th>
                    <th isSortable sortOn="username">{{ t('username') }}</th>
                    <th>{{ t('info') }}</th>
                  </tr>
                </ng-template>
                <ng-template let-row euiTemplate="body">
                  <tr>
                    <td>{{ row.email }}</td>
                    <td>{{ row.firstName }}</td>
                    <td>{{ row.lastName }}</td>
                    <td>{{ row.username }}</td>
                    <td>
                      <button class="eui-u-mt-s" euiButton type="button" euiPrimary (click)="showUserRoles(row)">
                        <eui-icon-svg icon="eui-ecl-information"></eui-icon-svg>
                        <span euiLabel>{{ t('info') }}</span>
                      </button>
                    </td>
                  </tr>
                </ng-template>
                <ng-template let-row euiTemplate="noData">
                  <tr>
                    <td class="eui-u-text-center" colspan="5">
                      {{ t('empty') }}
                    </td>
                  </tr>
                </ng-template>
                <ng-template euiTemplate="footer">
                  <tr>
                    <td class="eui-u-text-center" colspan="5">
                      <eui-paginator hasPageNumberNavigation [length]="data.length" [pageSizeOptions]="[5, 10, 25, 100]"
                        [page]="pagination.page" [pageSize]="pagination.pageSize" (pageChange)="onPageChange($event)"
                        [hasPageNumberNavigation]="true">
                      </eui-paginator>
                    </td>
                  </tr>
                </ng-template>
              </table>
            </div>
          </eui-page-column-body>
        </eui-page-column>
      </eui-page-columns>
    </eui-page-content>
  </eui-page>

  <eui-dialog #dialog [title]="roleDialogData.title" [dismissLabel]="roleDialogData.cancel">
    <app-role-list-modal [data]="roleDialogData"></app-role-list-modal>
  </eui-dialog>
</ng-container>
